// Bibliotheken zum Einbinden (Zufallszahlen, Ein-Ausgabe,Mathematik, GNUplot)
#include <cstdlib>
#include <stdio.h>
#include <math.h>
#include "hilf.h"
#include "vector2.h"  
#include <iostream>
#include "graphik.h"
using namespace std;

// Programm berechnet Pseudozufallszahlen nach Fibonaccigenerator
// Ausgabe: entweder alle Zufallszahlen oder graphisch 
//          ein Vektor aller Tripel aufeinanderfolgender Zahlen
int main()
{ long int m,z0,z1,z;
  long int k,n;
  float x,x1,xold;
  char ausg;

  // nur fuer Graphik
  double* xw;
  double* yw;
  double* zw;
  //

  cout<< "m eingeben:";
  cin >> m;
  cout<< "z0, z1 eingeben:";
  cin >> z0>> z1;
  cout<< "n eingeben:";
  cin >> n;
 
  // fuer die Graphik
  xw=(double*)malloc(n*sizeof(double)); 
  yw=(double*)malloc(n*sizeof(double));
  zw=(double*)malloc(n*sizeof(double));
  //

  x1=0;
  xold=0;
  for (k=1;k<n+1;k++)
    {
      z=(z0+z1)%m;
      z0=z1; 
      z1=z;
      xold=x1;
      x1=x;
      x=float(z)/float(m);
    // Hyperebenen fuer die Graphik
      if (k>2)
	{
          xw[k-3]=xold;
          yw[k-3]=x1;
          zw[k-3]=x;
        }
      //    
    }
  cout<<"Graphische Ausgabe (g), Zahlenausgabe (z)?";
  cin >>ausg;
  if (ausg=='g')
    PlotResults3D(xw,yw,zw,n-2);
  else if (ausg=='z')
    ausgabe(zw,n-2);
  
  free(xw);
  free(yw);
  free(zw); 
   
  return 0;
}
